#!/usr/bin/python
import sys
import os
import re
import cPickle
from threading import Thread
from threading import Semaphore

class SemCount:
    def __init__(self):
        self.count = 0

class PageParser(Thread):
    def __init__(self, files, doneCount):
        Thread.__init__(self)

        self.files = files

        self.count = {}
        self.doneCount = doneCount

    def run(self):
        temp = "1"
        for path in self.files:
            print path
            #    size = os.stat(path)[6]
            #except:
            #    continue
            if os.access(path,os.R_OK):
                try:
                    temp2=os.listdir(path)
                except OSError, err:
                    file = open(path, 'rb')
                    stripped = re.sub("<[^>]+>", "", file.read(os.stat(path)[6]))
                    results = re.split("\s+", stripped)
                    temp = path[3]
                    for word in results:
                        word = word.lower()
                        word = re.sub("[^a-z]", "", word)
                        if word != "":
                            if not word in self.count.keys():
                                self.count[word] = []
                                self.count[word].append(0)
                                self.count[word].append({})
                            self.count[word][0] += 1
                            if not path in self.count[word][1].keys():
                                self.count[word][1][path] = 1
                            else:
                                self.count[word][1][path] += 1
                    file.close()
        self.doneCount.count += 1
        print "I AM DONE (" + str(doneCount.count) + ")" + temp
        waitSemaphore.release()

if __name__ == "__main__":
    filelistpath = "addressDict"
    filelist = open(filelistpath, 'rb')
            
    count = {}

    letters = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
               'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']

    letterArray = cPickle.load(filelist)
    filelist.close()
	
    results = {}

    waitSemaphore = Semaphore(0)

    parser = {}

    doneCount = SemCount()

    for letter in letters:
        parser[letter] = PageParser(letterArray[letter], doneCount)
        parser[letter].start()

    for i in range(len(letters)):
        print "Trying: " + str(i+1)
        waitSemaphore.acquire()
        print "Acquired: " + str(i+1)

    for letter in letters:
        results[letter] = parser[letter].count

    for resultkey in results:
        print "Loop 1: " + str(resultkey)
        result = results[resultkey]
        for wordkey in result:
            word = result[wordkey]
            if not wordkey in count.keys():
                count[wordkey] = []
                count[wordkey].append(0)
                count[wordkey].append({})
            count[wordkey][0] += word[0]
            for location in word[1]:
                count[wordkey][1][location] = word[1][location]

    print "Writing to files"
    outfile = open("wordsDict", 'w')
    cPickle.dump(count, outfile)
    outfile.close()
    '''outfile = open("results.txt", 'w')

    top100 = {}
    i = 0
    for countkey in count:
        top100[countkey] = count[countkey]
        i += 1
        if i == 100:
            break
    
    cPickle.dump(top100, outfile)
    outfile.close()'''
