#!/usr/bin/python
import cPickle
import re
import cgi

class GeneratePage:
    def __init__(self):
        print "Content-type:text/html\n";

        self.results = cPickle.load(open("resultsDict"))
        self.pages = cPickle.load(open("addressDict"))

        self.fields = cgi.FieldStorage()
        if "word" in self.fields.keys():
            self.wordDetail(self.fields["word"].value)
        elif "files" in self.fields.keys():
            self.fileList(self.fields["files"].value)
        else:
            self.mainPage()

    def mainPage(self):
        layout = open("index.html", 'r')
        for line in layout.readlines():
            print re.sub("\$toplist", self.printResults(), line)

    def fileList(self,files):
        layout =open("list.html", 'r')
        for line in layout.readlines():
            print re.sub("\$files", self.getFiles(files), line)

    def getFiles(self,files):
        links = "<ul>\n"
        for letter in self.pages:
            for page in self.pages[letter]:
                try:
                    displayUrl = self.convertUrl(page)
                    links += "<li><a href=\"" + displayUrl + "\">" + displayUrl + "</a></li>\n"
                except:
                    continue
        links += "</ul>"
        return links

    def printResults(self):
        top100  = "<table border=\"1\">\n"
        top100 += "<thead>\n"
        top100 += "<tr><td>Word</td><td>Occurences</td></tr>\n"
        top100 += "</thead>\n"
        pairing = []
        for key in self.results:
            pairing.append((self.results[key][0], key))
        pairing.sort()
        pairing.reverse()
        for pair in pairing:
            top100 += "<tr><td><a href=\"top100.py?word=" + pair[1] + "\">" + pair[1]
            top100 += "</a></td><td>" + str(pair[0]) + "</td></tr>\n"
        top100 += "</table>"
        return top100

    def wordDetail(self, word):
        #substitutions = [re.sub("\$word", word, subline),
        #                 re.sub("\$count", str(self.results[word][0]), subline),
        #                 re.sub("\$pages", str(self.results[word][1].keys()), subline)]
        layout = open("wordDetail.html", 'r')
        for line in layout.readlines():
            subline = line
            subline = re.sub("\$word", word, subline)
            subline = re.sub("\$count", str(self.results[word][0]), subline)
            subline = re.sub("\$pages", self.getPages(word), subline)
            #for substitution in substitutions:
            #    print "subline: " + subline
            #    self.subline = substitution
            print subline

    def getPages(self, word):
        users = {}
        counts = {}
        for url in self.results[word][1]:
            user = re.split("/", url, 7)[4]
            if not user in users.keys():
                users[user] = []
                counts[user] = 0
            counts[user] += self.results[word][1][url]
            displayUrl = self.convertUrl(url)
            link = "<li><a href=\"" + displayUrl + "\">" + displayUrl + "</a> "
            link += str(self.results[word][1][url]) + " instances</li>\n"
            users[user].append(link)
        links = "<ul>\n"
        for user in users:
            links += "<li>" + user + " used \"" + word + "\" " + str(counts[user]) + " times: <a onclick=\"shoh('" + user + "');\" style=\"color:green; text-decoration:underline;\" id=\"" + user + "toggle\">show pages</a>\n"
            links += "<ul style=\"display: none;\" id=\"" + user + "\">\n"
            for link in users[user]:
                links += link
            links += "</ul>\n"
            links += "</li>\n"
        links += "</ul>"
        return links

    def convertUrl(self, url):
        split = re.split("/", url, 7)
        return "http://www.cs.wisc.edu/~" + split[4] + "/" + split[7]

page = GeneratePage()
#fields = cgi.FieldStorage()
#for key in fields.keys():
#    print str((key, fields[key].value))
